#pragma once
#include <gfx/vec2.h>
#include "VectorField.h"

class VelocityField;

class ScalarField
{
public:
	ScalarField(int a_NumCells, float a_Viscosity, float a_Dt);
	ScalarField(ScalarField *CopyField);
	virtual ~ScalarField(void);

	void	TimeStep(ScalarField *a_SrcField, VectorField *VelocityField);
	void	AddField(ScalarField *a_SrcField);
    void    Advection(VectorField * VelocityField);
    float   interp(Vec2f & pos);
	float	&operator[](int i)       { return m_Field[i]; }

	int		m_NumCells;
	float	*m_Field;
	float	*new_Field;
	float	m_Viscosity;
	float	m_Dt;

	float   dx;
	/**@brief origin of the field
        only used for rendering
        when computing origin is 0,0)
	*/
	Vec2f   O;
	int dim;
	Vec2f   g;
};
