#pragma once
#include <queue>
#include <vector>
#include <cmath>
#include <utility>
#include <stdio.h>
#include <gfx/vec2.h>
using namespace std;

/*******
types
********/
typedef pair<int,float> intfloat;
class mycmp
{
public:
  float * f;
  mycmp(float*field):f(field){}
  bool operator() (const intfloat& lhs, const intfloat&rhs) const
  {
    return (lhs.second>rhs.second);
  }
};
typedef priority_queue<intfloat, vector <intfloat> ,mycmp > PQ;
typedef enum{
	FAR,
	CLOSE,
	ACCEPTED
}Status;


/**
function declarations
**********/
void march(float * field, float * dst, Vec2f* vf, int m_NumCells);
void field_init(float * src, float *dst, int m_NumCells,PQ& pq);
void redist(float*src, float * dst, int m_NumCells);
void field_init(float * src,float*dst, int m_NumCells,PQ& pq);
Status init_point(int i, int j, float*src,float*dst,int m_NumCells);
void redist(float * field, float * dst, int m_NumCells);
void update_cell(int i, int j,float * dst,int m_NumCells);
void print_field(float * field, int m_NumCells);
void print_vf(Vec2f * vf, int m_NumCells);
